## camitk 3.0.2

=== CMakeLists.txt ===
#
# CamiTK CMakeLists
#
# WARNING!
# CamiTK macros (component_extension, application_extension...) use GLOB to collect a 
# list of source files from your source tree, which means that if no CMakeLists.txt file changes 
# when a new source file is added or removed to your project then the generated build system 
# cannot know when to ask CMake to regenerate.
# => DO NOT FORGET to regenerate CMake in case you add/remove a source file to your project

# all CMake project names and variables should be in uppercase
project(CAMITK)

cmake_minimum_required(VERSION 2.6)

# Find Qt (Qt4 without Qt3 support!)
find_package(Qt4 REQUIRED)
include(${QT_USE_FILE})
set (QT_USE_QT3SUPPORT OFF)

# Find VTK
find_package(VTK REQUIRED)
include(${VTK_USE_FILE})

# Configure CamiTK
# update module path
set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${CAMITK_SOURCE_DIR}/cmake/modules)
# include CamiTK Internal Build environment
include(CamiTKInternalBuild)
# include CamiTK variables
include(CamiTKVariables)
# include CamiTK generic macros from CMAKE_MODULE_PATH directory
include(CamiTKMacros)
# include CamiTK log configuration
include(CamiTKLog)
# include CamiTK auto-documentation generation
include(CamiTKApiDoc)
# include CamiTK package generation
include(CamiTKPackaging)
# enables to specify which target to launch to MSVC
include(CreateLaunchers)

add_subdirectory(tools)
add_subdirectory(core)
add_subdirectory(components)
add_subdirectory(actions)
add_subdirectory(applications) # needs to be put at the end
add_subdirectory(cmake) # rules for cmake install

# For Microsoft Visual C++, sets the default application to imp for the "ALL_BUILD" project
# (i.e. launches imp when we you click on "Debug" or "Start Without Debugging" button on Visual)
# In addition, but not the least, sets the environment to the debug dll directory for VTK (and ITK)
#     to solve the dll incompatibility between debug and relase version of QVTK.dll and ITKCommon.dll
if ( MSVC )
	create_default_target_launcher(
		application-imp
		RUNTIME_LIBRARY_DIRS "%VTK_DIR%/bin/$(OutDir)" "%ITK_DIR%/bin/$(OutDir)"
	)		
endif( MSVC )

=== components/CMakeLists.txt ===
#
# DO NOT EDIT THIS FILE (unless you REALLY know what you are doing)
#
# To add a component, just add a subdirectory (the component name is the 
# directory name). Add all your code there and a text file called
# CMakeLists.txt 
# In your CMakeLists.txt, use the component_extension() macro apropriately

# Add subdirectories in CMake project but respect a specific
# order (i.e., consider components inter dependencies)
add_subdirectory(vtkimage)
add_subdirectory(vtkmesh)
add_subdirectory(dicom)
add_subdirectory(itkimage)
add_subdirectory(msh)
add_subdirectory(obj)
add_subdirectory(vrml)
add_subdirectory(physicalmodel)
add_subdirectory(mml)

=== core/CMakeLists.txt ===
# Don't forget to include output directory, otherwise
# the UI file won't be wrapped!
include_directories(
  ${CMAKE_CURRENT_BINARY_DIR}
  ${CMAKE_CURRENT_SOURCE_DIR}
  ${CMAKE_CURRENT_SOURCE_DIR}/action
  ${CMAKE_CURRENT_SOURCE_DIR}/application
  ${CMAKE_CURRENT_SOURCE_DIR}/component
  ${CMAKE_CURRENT_SOURCE_DIR}/component/mesh
  ${CMAKE_CURRENT_SOURCE_DIR}/component/image
  ${CMAKE_CURRENT_SOURCE_DIR}/operators
  ${CMAKE_CURRENT_SOURCE_DIR}/utils
  ${CMAKE_CURRENT_SOURCE_DIR}/viewer
  ${CAMITK_INCLUDE_DIRECTORIES}
)

# find all sources files, set rules for qt files...
gather_headers_and_sources(${CAMITK_CORE_LIB}) 

# Needed for a correct CamiTK core plugin management (decl export/import) on WIN32
add_definitions(-DCOMPILE_CAMITK_API)

# prepare the library specific info (SONAME...)
set(CAMITKCORE_LIBRARY_PROPERTIES ${CAMITKCORE_LIBRARY_PROPERTIES}
    VERSION   "${CAMITK_VER_MAJ}.${CAMITK_VER_MIN}.${CAMITK_VER_PAT}"
    SOVERSION "${CAMITK_VER_MAJ}.${CAMITK_VER_MIN}"
)

# CAMITK_CORE_LIB needs to be SHARED and loaded only ONCE otherwise the extensions
# can have their own copy of CAMITK_CORE_LIB, which will generates loads of problems
# because of the Singleton design pattern and various factory bits in CAMITK_CORE_LIB.
add_library(${CAMITK_CORE_LIB} SHARED ${${CAMITK_CORE_LIB}_SOURCES})

# set the library specific info (SONAME...)
set_target_properties(${CAMITK_CORE_LIB} PROPERTIES ${CAMITKCORE_LIBRARY_PROPERTIES} LINK_INTERFACE_LIBRARIES "")

target_link_libraries(${CAMITK_CORE_LIB} ${CAMITK_LIBRARIES})

add_dependencies(${CAMITK_CORE_LIB} qtpropertybrowser)

# -- headers to install 
# TODO create a manually selected list (some headers are just needed internally)
# TODO create few specific include files like: CamiTKCore and CamiTKComponent that
# include most of the needed headers and that can be used simply e.g.
# #include <CamiTKComponent>
# i.e. without the trailing .h
file(GLOB_RECURSE ${CAMITK_CORE_LIB}_INSTALL_H *.h *.txx)

#--------------
# installation
#--------------
export_headers(${${CAMITK_CORE_LIB}_INSTALL_H} 
               COMPONENT ${CAMITK_CORE_LIB}
)

# lib installation
install(TARGETS ${CAMITK_CORE_LIB}
        RUNTIME DESTINATION bin
        LIBRARY DESTINATION lib
        ARCHIVE DESTINATION lib/${CAMITK_SHORT_VERSION_STRING}
        COMPONENT           ${CAMITK_CORE_LIB}
)

=== tools/CMakeLists.txt ===
project(TOOLS)

# list of TOOLS (option)
set(TOOLS_LIST lml pml mml coreschema)
# qtpropertybrowser is mandatory
set(TOOLS_SUBDIRS qtpropertybrowser)

#set(CMAKE_VERBOSE_MAKEFILE ON CACHE BOOL "Verbose makefile" FORCE)
set(TOOLS_INCLUDE_DIRECTORIES ${CAMITK_INCLUDE_DIRECTORIES})
set(TOOLS_LIBRARIES ) # Those libraries do not depend on anything...

foreach(TOOL_NAME ${TOOLS_LIST})
  string(TOUPPER ${TOOL_NAME} TOOL_NAME_CMAKE)
  if(NOT CAMITK_TOOL_${TOOL_NAME_CMAKE}_INTERNAL)
      message(STATUS "Checking ${TOOL_NAME}")
      # add option to enable/disable this tool
      set(TOOL_${TOOL_NAME_CMAKE} FALSE CACHE BOOL "Build tool ${TOOL_NAME}")
      set(CAMITK_TOOL_${TOOL_NAME_CMAKE}_INTERNAL TRUE CACHE BOOL "Is variable CAMITK_TOOL_${TOOL_NAME_CMAKE}_INTERNAL already created?")
      mark_as_advanced(CAMITK_TOOL_${TOOL_NAME_CMAKE}_INTERNAL)
    endif()
endforeach()

foreach(TOOL_NAME ${TOOLS_LIST})
  string(TOUPPER ${TOOL_NAME} TOOL_NAME_CMAKE)
  if (TOOL_${TOOL_NAME_CMAKE})
    set(TOOLS_SUBDIRS ${TOOLS_SUBDIRS} ${TOOL_NAME})
  endif()
endforeach()

# Add subdirectories in CMake project
foreach(TOOL_NAME ${TOOLS_SUBDIRS})
  add_subdirectory(${TOOL_NAME})
  message(STATUS "Building tool ${TOOL_NAME}") 
endforeach()

=== actions/application/CMakeLists.txt ===
action_extension(DEFAULT
DEFINES COMPILE_APPLICATION_ACTION_API
)

=== actions/image/CMakeLists.txt ===
#
# DO NOT EDIT THIS FILE (unless you REALLY know what you are doing)
#
# To add a component, just add a subdirectory (the component name is the 
# directory name). Add all your code there and a text file called
# CMakeLists.txt 
# In your CMakeLists.txt, use the action_extension() macro apropriately

# Add subdirectories in CMake project but respect a specific
# order (i.e., consider actions inter dependencies)
add_subdirectory(imagelut)
add_subdirectory(reconstruction)
add_subdirectory(volumerendering)
add_subdirectory(multipicking)
add_subdirectory(itksegmentation)  
add_subdirectory(itkfilters)

=== applications/imp/CMakeLists.txt ===
application_extension(DEFAULT)

=== applications/objectcontroller/CMakeLists.txt ===
application_extension()

=== applications/wizard/CMakeLists.txt ===
# specific section in order to use the XML module of Qt
if(APPLICATION_WIZARD)
     set (QT_USE_QTWEBKIT ON)
     set (QT_USE_QTXML ON)
     set (QT_USE_QTXMLPATTERNS ON)
    find_package(Qt4 REQUIRED)
    if(QT_USE_FILE)
	include(${QT_USE_FILE})
    else(QT_USE_FILE)
	set(QT_LIBRARIES ${QT_QT_LIBRARY})
    endif(QT_USE_FILE)
    # warning: redefines CAMITK_LIBRARIES
    set(CAMITK_LIBRARIES ${CAMITK_LIBRARIES} ${QT_LIBRARIES})
endif()

# use the application extension macro
application_extension(NEEDS_XSD
                      NEEDS_XERCESC
                      NEEDS_TOOL coreschema)

if(APPLICATION_WIZARD)
    # build-time FindCamiTK.cmake install
    # check directory
    set(FIND_CAMITK_BUILD_TIME_DIR ${CAMITK_BUILD_DIR}/share/cmake)
    if (NOT EXISTS ${FIND_CAMITK_BUILD_TIME_DIR})
        add_custom_command( TARGET application-wizard
                            POST_BUILD
                            COMMAND ${CMAKE_COMMAND} -E make_directory ${FIND_CAMITK_BUILD_TIME_DIR}
                            COMMENT "Creating build-time group include dir ${FIND_CAMITK_BUILD_TIME_DIR}"
                            VERBATIM
        )
    endif()

    # copy after build, only if there was a change
    add_custom_command( TARGET application-wizard
                        POST_BUILD
                        COMMAND ${CMAKE_COMMAND} -E copy_if_different ../../cmake/modules/FindCamiTK.cmake ${FIND_CAMITK_BUILD_TIME_DIR}/
                        COMMENT "Installing build-time FindCamiTK.cmake"
                        WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
                        VERBATIM
    )
endif()

=== components/dicom/CMakeLists.txt ===
# dicom component just needs to use the component_extension macro
component_extension(NEEDS_ITK 
#                    LIBRARIES ITKBasicFilters ITKCommon ITKIO
)

=== components/itkimage/CMakeLists.txt ===
# itkimage component just needs to use the component_extension macro
component_extension(NEEDS_ITK 
)

=== components/mml/CMakeLists.txt ===
if(COMPONENT_MML)
    set(MML_GENERATE_GUI ON CACHE BOOL "Forced by COMPONENT_MML" FORCE)
	
	#FIXME Sofa support => fix sofa dependency properly
	if(MML_SOFA_SUPPORT)
		if(WIN32)
			set(MML_SOFA_LIB_DIR ${MML_SOFA_DIR}/lib/win32/ReleaseVC9 ${MML_SOFA_DIR}/lib/win32 ${MML_SOFA_DIR}/lib ${MML_SOFA_DIR}/bin)
		else()
			set(MML_SOFA_LIB_DIR ${MML_SOFA_DIR}/lib/linux ${MML_SOFA_DIR}/lib)
		endif()
		link_directories(${MML_SOFA_LIB_DIR})
	endif()	
	#FIXME xerces-c/xsd dependency properly (if mml is needed, xerces-c and xsd are needed)
	include_directories(${XERCESC_ROOT_DIR}/include)


	
endif()

component_extension(NEEDS_LIBXML2
                    NEEDS_TOOL pml lml mml monitoringgui monitoring
                    NEEDS_COMPONENT_EXTENSION  vtkmesh physicalmodel
                    HEADERS_TO_INSTALL  MMLComponentExtension.h
                                        MMLComponent.h
                                        MMLDisplay.h
                                        MMLMonitorDisplay.h
                                        MMLMonitorDisplayFactory.h
                                        MMLMonitorDisplays/Colors.h
                                        MMLMonitorDisplays/Arrows.h
					MMLMonitorDisplays/Tabular.h
					MMLComponentPopup.h
)

if(COMPONENT_MML)
	#FIXME this is just to avoid link error for MSVC:
	# msvc2008 (v9) cannot link mml.dll (the component) with the mml.lib (the tool)
	# it complains it can not link with mml with itself, without considering it 
	# can be two different libs
	if(WIN32)
		set_target_properties(component-mml PROPERTIES OUTPUT_NAME component-mml)
	endif()
endif()

=== debian/changelog ===
camitk (3.0.2-1) unstable; urgency=low

  * Initial release (Closes: #682109)

 -- Emmanuel Promayon <Emmanuel.Promayon@imag.fr>  Thu, 26 Jul 2012 15:55:23 +0200

=== debian/control ===
Source: camitk
Section: science
Priority: optional
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
DM-Upload-Allowed: yes
Uploaders: Andreas Tille <tille@debian.org>, Mathieu Malaterre <malat@debian.org>, Emmanuel Promayon <Emmanuel.Promayon@imag.fr>
Build-Depends: debhelper (>= 9), cmake (>= 2.6), libvtk5-dev (>= 5.6), libqt4-dev (>= 4.6), libvtk5-qt4-dev (>= 5.6), xsdcxx (>= 3.2), libinsighttoolkit3-dev (>= 3.18), libxerces-c-dev (>= 3.1), libxml2-dev (>= 2.7), libgdcm2-dev (>= 2.0), libfftw3-dev, libqtwebkit-dev | libqt4-dev (<< 4.7)
Build-Depends-Indep: doxygen, graphviz
Standards-Version: 3.9.3
Homepage: http://camitk.imag.fr/
X-Homepage: https://forge.imag.fr/projects/camitk/
Vcs-Browser: http://svn.debian.org/wsvn/debian-med/trunk/packages/camitk/trunk/
Vcs-Svn: svn://svn.debian.org/debian-med/trunk/packages/camitk/trunk/

Package: libcamitk3
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Computer Assisted Medical Intervention Tool Kit - runtime
 Helps researchers and clinicians to easily and rapidly collaborate in
 order to prototype CAMI applications, that feature medical images,
 surgical navigation and biomechanical simulations.
 .
 This package contains the shared libraries needed to run CamiTK applications.

Package: libcamitk3-dev
Architecture: any
Section: libdevel
Depends: libcamitk3 (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
Description: Computer Assisted Medical Intervention Tool Kit - development
 Helps researchers and clinicians to easily and rapidly collaborate in
 order to prototype CAMI applications, that feature medical images,
 surgical navigation and biomechanical simulations. 
 .
 This package contains development files needed to build CamiTK applications.
 This package also provides the CamiTK wizard to create new extensions.

Package: libcamitk3-data
Architecture: all
Section: doc
Depends: ${misc:Depends}
Description: Computer Assisted Medical Intervention Tool Kit - data
 Helps researchers and clinicians to easily and rapidly collaborate in
 order to prototype CAMI applications, that feature medical images,
 surgical navigation and biomechanical simulations.
 .
 This package contains the example and test data for CamiTK.

Package: libcamitk3-doc
Architecture: all
Section: doc
Depends: ${misc:Depends}
Description: Computer Assisted Medical Intervention Tool Kit - documentation
 Helps researchers and clinicians to easily and rapidly collaborate in
 order to prototype CAMI applications, that feature medical images,
 surgical navigation and biomechanical simulations. 
 .
 This package contains the documentation for CamiTK.

Package: camitk-imp
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: flagship application for the CamiTK library
 CamiTK Helps researchers and clinicians to easily and rapidly collaborate in
 order to prototype CAMI applications, that feature medical images,
 surgical navigation and biomechanical simulations.
 .
 imp is the CamiTK flagship application.

=== debian/rules ===
#!/usr/bin/make -f

# DH_VERBOSE := 1

export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

CMAKE_EXTRA_FLAGS = \
	-DCMAKE_SKIP_RPATH=ON \
	-DCMAKE_BUILD_TYPE:STRING=RelWithDebInfo \
	-DCAMITK_INSTALL_ROOT:PATH=/usr \
	-DTOOL_CORESCHEMA:BOOL=ON \
	-DTOOL_LML:BOOL=TRUE \
	-DTOOL_PML:BOOL=TRUE \
        -DMML_GENERATE_GUI:BOOL=ON \
	-DTOOL_MML:BOOL=TRUE \
	-DMML_GENERATE_XSD_LIB:BOOL=TRUE \
	-DACTION_ITKSEGMENTATION:BOOL=TRUE \
	-DACTION_ITKFILTERS:BOOL=TRUE \
	-DAPPLICATION_WIZARD:BOOL=TRUE \
	-DCOMPONENT_VTKMESH:BOOL=TRUE \
	-DCOMPONENT_DICOM:BOOL=TRUE \
	-DCOMPONENT_ITKIMAGE:BOOL=TRUE \
	-DCOMPONENT_PHYSICALMODEL:BOOL=TRUE \
	-DCOMPONENT_MML:BOOL=TRUE \
	-DAPIDOC_GENERATE_FOR_CAMITK_CORE:BOOL=TRUE

%:
	dh $@ --parallel

override_dh_auto_configure:
	dh_auto_configure -- $(CMAKE_EXTRA_FLAGS)

VER_MAJOR=3
VER_MINOR=0
VER_SHORT=$(VER_MAJOR).$(VER_MINOR)

pkg_lib = libcamitk$(VER_MAJOR)
pkg_dev = libcamitk$(VER_MAJOR)-dev
pkg_data = libcamitk$(VER_MAJOR)-data
pkg_doc = libcamitk$(VER_MAJOR)-doc
pkg_imp = camitk-imp

# let's be smart with doc
override_dh_auto_build-indep:
	$(MAKE) -C obj-* apidoc
	# remove the javascript search field
	rm -f obj-*/share/apidoc/html/jquery.js

# No tests needed for docs
override_dh_auto_test-indep:

override_dh_install:
	# camitk dynamic library
	dh_install -p$(pkg_lib) debian/tmp/usr/lib/lib*.so.* usr/lib 
	dh_install -p$(pkg_lib) --autodest debian/tmp/usr/lib/camitk-$(VER_SHORT)/actions/lib*.so
	dh_install -p$(pkg_lib) --autodest debian/tmp/usr/lib/camitk-$(VER_SHORT)/components/lib*.so

	# camitk headers and static libs + wizard
	dh_install -p$(pkg_dev) debian/tmp/usr/lib/lib*.so usr/lib 
	dh_install -p$(pkg_dev) debian/tmp/usr/bin/camitk-wizard
	dh_install -p$(pkg_dev) --autodest debian/tmp/usr/lib/camitk-$(VER_SHORT)/lib*.a
	dh_install -p$(pkg_dev) --autodest debian/tmp/usr/include
	dh_install -p$(pkg_dev) --autodest debian/tmp/usr/share/camitk-$(VER_SHORT)/cmake/*.cmake 
	dh_installman -p$(pkg_dev) $(CURDIR)/applications/wizard/camitk-wizard.1

	# api doc
	dh_install -p$(pkg_doc) --autodest debian/tmp/usr/share/camitk-$(VER_SHORT)/apidoc

	# all test data
	dh_install -p$(pkg_data) --autodest debian/tmp/usr/share/camitk-$(VER_SHORT)/testdata

	# imp
	dh_install -p$(pkg_imp) debian/tmp/usr/bin/camitk-imp
	dh_installman -p$(pkg_imp) $(CURDIR)/applications/imp/camitk-imp.1

# see http://lists.debian.org/debian-mentors/2012/07/msg00124.html
get-orig-source:
	PERL_LWP_SSL_VERIFY_HOSTNAME=0 uscan --rename --verbose --force-download --destdir=../tarballs

=== debian/watch ===
version=3
http://camitk.imag.fr/download_source.xml \
   https://forge.imag.fr/frs/download.php/[\d]+/camitk-([\d.]+)\.tar\.gz

## camitk 3.0.7

=== CMakeLists.txt ===
--- 
+++ 
@@ -12,6 +12,11 @@
 project(CAMITK)
 
 cmake_minimum_required(VERSION 2.6)
+
+# Continous integration support
+enable_testing()
+include(CTest)
+
 
 # Find Qt (Qt4 without Qt3 support!)
 find_package(Qt4 REQUIRED)
@@ -40,12 +45,23 @@
 # enables to specify which target to launch to MSVC
 include(CreateLaunchers)
 
+# Create the Xml data for Project.xml description, fyi store in the global variable CAMITK_XML_PROJECT_DESCRIPTION
+initXmlSubProject()
+
+# add all subprojects
+add_subdirectory(cmake) # rules for cmake install
+add_subdirectory(applications)
+add_subdirectory(actions)
+add_subdirectory(components)
+add_subdirectory(core)
 add_subdirectory(tools)
-add_subdirectory(core)
-add_subdirectory(components)
-add_subdirectory(actions)
-add_subdirectory(applications) # needs to be put at the end
-add_subdirectory(cmake) # rules for cmake install
+
+# Validate and write down the Project.xml file
+# This file contains all the CamiTK project description with subprojects and their CMake target dependencies
+# This file is needed for CDash to correctly update the Dashboard accordingly to the project
+# Thus, CDash continuous integration dashboard is automatically updated when adding a new extension 
+# to CamiTK, using the corresponding macro
+validateXmlSubProjects(${CAMITK_BUILD_DIR})
 
 # For Microsoft Visual C++, sets the default application to imp for the "ALL_BUILD" project
 # (i.e. launches imp when we you click on "Debug" or "Start Without Debugging" button on Visual)

=== actions/CMakeLists.txt ===
#
# DO NOT EDIT THIS FILE (unless you REALLY know what you are doing)
#
# To add a component, just add a subdirectory (the component name is the 
# directory name). Add all your code there and a text file called
# CMakeLists.txt 
# In your CMakeLists.txt, use the action_extension() macro apropriately

# find components
get_subdirectories(ACTIONS_LIST)

# Add subdirectories in CMake project
foreach(ACTION_NAME ${ACTIONS_LIST})
  add_subdirectory(${ACTION_NAME})
endforeach()

=== cmake/CMakeLists.txt ===
# Save the compiler settings so another project can import them.
include(${CMAKE_ROOT}/Modules/CMakeExportBuildSettings.cmake)
cmake_export_build_settings(${CMAKE_CURRENT_BINARY_DIR}/../CamiTKBuildSettings.cmake)
install(FILES "${CMAKE_CURRENT_BINARY_DIR}/../CamiTKBuildSettings.cmake"
        DESTINATION lib/${CAMITK_SHORT_VERSION_STRING}/cmake
        COMPONENT cmake-modules)

# install the cmake files
file(GLOB CAMITK_CMAKE_FILES "modules/*.cmake")
set(SHARE_CMAKE_PATH) 
if ( MSVC )
	# Do NOT add ${CAMITK_SHORT_VERSION_STRING} to the share/cmake path for Win32 MSVC !
	set (SHARE_CMAKE_PATH share/cmake)
 else ()
	set (SHARE_CMAKE_PATH share/${CAMITK_SHORT_VERSION_STRING}/cmake)
endif ()

install(FILES ${CAMITK_CMAKE_FILES}
        DESTINATION ${SHARE_CMAKE_PATH}
        COMPONENT cmake-modules)

file(GLOB CAMITK_CMAKE_FILES "modules/launcher-templates/*.in")
install(FILES ${CAMITK_CMAKE_FILES}
        DESTINATION ${SHARE_CMAKE_PATH}/launcher-templates
        COMPONENT cmake-modules)

=== components/CMakeLists.txt ===
--- 
+++ 
@@ -8,12 +8,11 @@
 
 # Add subdirectories in CMake project but respect a specific
 # order (i.e., consider components inter dependencies)
-add_subdirectory(vtkimage)
-add_subdirectory(vtkmesh)
-add_subdirectory(dicom)
-add_subdirectory(itkimage)
-add_subdirectory(msh)
-add_subdirectory(obj)
-add_subdirectory(vrml)
-add_subdirectory(physicalmodel)
-add_subdirectory(mml)
+
+get_subdirectories(COMPONENTS_LIST)
+
+# Add subdirectories in CMake project
+foreach(COMPONENT_NAME ${COMPONENTS_LIST})
+  add_subdirectory(${COMPONENT_NAME})
+endforeach()
+

=== core/CMakeLists.txt ===
--- 
+++ 
@@ -23,13 +23,16 @@
 # prepare the library specific info (SONAME...)
 set(CAMITKCORE_LIBRARY_PROPERTIES ${CAMITKCORE_LIBRARY_PROPERTIES}
     VERSION   "${CAMITK_VER_MAJ}.${CAMITK_VER_MIN}.${CAMITK_VER_PAT}"
-    SOVERSION "${CAMITK_VER_MAJ}.${CAMITK_VER_MIN}"
+    SOVERSION "${CAMITK_VER_MAJ}"
 )
 
 # CAMITK_CORE_LIB needs to be SHARED and loaded only ONCE otherwise the extensions
 # can have their own copy of CAMITK_CORE_LIB, which will generates loads of problems
 # because of the Singleton design pattern and various factory bits in CAMITK_CORE_LIB.
 add_library(${CAMITK_CORE_LIB} SHARED ${${CAMITK_CORE_LIB}_SOURCES})
+# Update XML Project description adding this target as a subproject of the main CamiTK project with
+# its dependencies (in the CMake target point of view)
+addSubProject(${CAMITK_CORE_LIB})
 
 # set the library specific info (SONAME...)
 set_target_properties(${CAMITK_CORE_LIB} PROPERTIES ${CAMITKCORE_LIBRARY_PROPERTIES} LINK_INTERFACE_LIBRARIES "")

=== tools/CMakeLists.txt ===
--- 
+++ 
@@ -1,7 +1,7 @@
 project(TOOLS)
 
 # list of TOOLS (option)
-set(TOOLS_LIST lml pml mml coreschema)
+set(TOOLS_LIST lml pml qcustomplot mml coreschema)
 # qtpropertybrowser is mandatory
 set(TOOLS_SUBDIRS qtpropertybrowser)
 
@@ -32,4 +32,3 @@
   add_subdirectory(${TOOL_NAME})
   message(STATUS "Building tool ${TOOL_NAME}") 
 endforeach()
-

=== actions/application/CMakeLists.txt ===
camitk_extension(	
ACTION_EXTENSION
DEFAULT
DEFINES COMPILE_APPLICATION_ACTION_API
)

if(NOT ACTION_APPLICATION)
    message(FATAL_ERROR "ACTION_APPLICATION cannot be set to OFF, it is mandatory for any CamiTK applications")
endif()

=== actions/image/CMakeLists.txt ===
--- 
+++ 
@@ -14,4 +14,6 @@
 add_subdirectory(multipicking)
 add_subdirectory(itksegmentation)  
 add_subdirectory(itkfilters)
+add_subdirectory(arbitraryslice)
+add_subdirectory(showin3d)

=== actions/mesh/CMakeLists.txt ===
#
# DO NOT EDIT THIS FILE (unless you REALLY know what you are doing)
#
# To add a component, just add a subdirectory (the component name is the 
# directory name). Add all your code there and a text file called
# CMakeLists.txt 
# In your CMakeLists.txt, use the action_extension() macro apropriately

# find components
get_subdirectories(ACTIONS_MESH_LIST)

# Add subdirectories in CMake project
foreach(ACTION_MESH_NAME ${ACTIONS_MESH_LIST})
  add_subdirectory(${ACTION_MESH_NAME})
endforeach()

=== applications/actionstatemachine/CMakeLists.txt ===
if(APPLICATION_ACTIONSTATEMACHINE)
	# specific section in order to use the XML module of Qt
     set (QT_USE_QTWEBKIT ON)
     set (QT_USE_QTXML ON)
     set (QT_USE_QTXMLPATTERNS ON)
    find_package(Qt4 REQUIRED)
    if(QT_USE_FILE)
	include(${QT_USE_FILE})
    else(QT_USE_FILE)
	set(QT_LIBRARIES ${QT_QT_LIBRARY})
    endif(QT_USE_FILE)
    # warning: redefines CAMITK_LIBRARIES
    set(CAMITK_LIBRARIES ${CAMITK_LIBRARIES} ${QT_LIBRARIES})
endif()

# use the application extension macro
application_extension(
LIBRARIES QtXml4 QtXmlPatterns4
)

=== applications/wizard/CMakeLists.txt ===
--- 
+++ 
@@ -17,7 +17,7 @@
 application_extension(NEEDS_XSD
                       NEEDS_XERCESC
                       NEEDS_TOOL coreschema)
-
+                      
 if(APPLICATION_WIZARD)
     # build-time FindCamiTK.cmake install
     # check directory

=== components/dicom/CMakeLists.txt ===
# dicom component just needs to use the component_extension macro
camitk_extension(
COMPONENT_EXTENSION
NEEDS_ITK
)

=== debian/changelog ===
camitk (3.0.7-1) unstable; urgency=low

  [ Emmanuel Promayon ]
  * New upstream release. Fix extension inner dependencies.
    - Remove non-free tetgen from source. Closes: #689951 
    - Adding -fPIC to fix FTBFS on armhf and mipsel. Closes: #690830
  * Fix typo in d/control. Closes: #689021
    Remove patch applied upstream:
     - sonamefix.patch
  * Separate package libqtpropertybrowser3
  * Updated debian/watch submitted by Bart Martens

  [ Mathieu Malaterre ]
  * Remove DMUA (deprecated)
  * Bump Std-Vers to 3.9.4, no changes needed
  * Remove myself from Uploaders

 -- Emmanuel Promayon <Emmanuel.Promayon@imag.fr>  Thu, 14 Feb 2013 19:09:38 +0100

=== debian/control ===
--- 
+++ 
@@ -2,11 +2,10 @@
 Section: science
 Priority: optional
 Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
-DM-Upload-Allowed: yes
-Uploaders: Andreas Tille <tille@debian.org>, Mathieu Malaterre <malat@debian.org>, Emmanuel Promayon <Emmanuel.Promayon@imag.fr>
+Uploaders: Andreas Tille <tille@debian.org>, Emmanuel Promayon <Emmanuel.Promayon@imag.fr>
 Build-Depends: debhelper (>= 9), cmake (>= 2.6), libvtk5-dev (>= 5.6), libqt4-dev (>= 4.6), libvtk5-qt4-dev (>= 5.6), xsdcxx (>= 3.2), libinsighttoolkit3-dev (>= 3.18), libxerces-c-dev (>= 3.1), libxml2-dev (>= 2.7), libgdcm2-dev (>= 2.0), libfftw3-dev, libqtwebkit-dev | libqt4-dev (<< 4.7)
 Build-Depends-Indep: doxygen, graphviz
-Standards-Version: 3.9.3
+Standards-Version: 3.9.4
 Homepage: http://camitk.imag.fr/
 X-Homepage: https://forge.imag.fr/projects/camitk/
 Vcs-Browser: http://svn.debian.org/wsvn/debian-med/trunk/packages/camitk/trunk/
@@ -14,7 +13,7 @@
 
 Package: libcamitk3
 Architecture: any
-Depends: ${shlibs:Depends}, ${misc:Depends}
+Depends: libqtpropertybrowser3 (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
 Description: Computer Assisted Medical Intervention Tool Kit - runtime
  Helps researchers and clinicians to easily and rapidly collaborate in
  order to prototype CAMI applications, that feature medical images,
@@ -60,8 +59,29 @@
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}
 Description: flagship application for the CamiTK library
- CamiTK Helps researchers and clinicians to easily and rapidly collaborate in
+ CamiTK helps researchers and clinicians to easily and rapidly collaborate in
  order to prototype CAMI applications, that feature medical images,
  surgical navigation and biomechanical simulations.
  .
  imp is the CamiTK flagship application.
+
+Package: libqtpropertybrowser3
+Architecture: any
+Depends: ${shlibs:Depends}, ${misc:Depends}
+Description: Qt Property Browser Library - runtime
+ A framework providing a set of graphical editors for 
+ Qt properties similar to the one used in Qt Designer.
+ .
+ This package contains the shared libraries needed to run applications
+ linked against libqtpropertybrowser3.
+
+Package: libqtpropertybrowser3-dev
+Architecture: any
+Section: libdevel
+Depends: libqtpropertybrowser3 (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
+Description: Qt Property Browser Library - development
+ A framework providing a set of graphical editors for 
+ Qt properties similar to the one used in Qt Designer.
+ .
+ This package contains development files needed to build applications
+ using Qt Property Browser

=== debian/rules ===
--- 
+++ 
@@ -4,8 +4,28 @@
 
 export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed
 
+VER_MAJOR=3
+VER_MINOR=0
+VER_SHORT=$(VER_MAJOR).$(VER_MINOR)
+
+pkg_lib = libcamitk$(VER_MAJOR)
+pkg_qpb = libqtpropertybrowser$(VER_MAJOR)
+pkg_dev = libcamitk$(VER_MAJOR)-dev
+pkg_qpb_dev = libqtpropertybrowser$(VER_MAJOR)-dev
+pkg_data = libcamitk$(VER_MAJOR)-data
+pkg_doc = libcamitk$(VER_MAJOR)-doc
+pkg_imp = camitk-imp
+
+# dpkg-shlibdeps needs to know about camitk extension directories to manage inner-dependencies
+# between extensions (i.e., mml component extension depends on physicalmodel component extensions)
+# for component extensions:
+LD_LIBRARY_PATH:=$(LD_LIBRARY_PATH):$(CURDIR)/debian/${pkg_lib}/usr/lib/camitk-${VER_SHORT}/components/
+# for action extensions: 
+LD_LIBRARY_PATH:=$(LD_LIBRARY_PATH):$(CURDIR)/debian/${pkg_lib}/usr/lib/camitk-${VER_SHORT}/actions/
+
 CMAKE_EXTRA_FLAGS = \
-	-DCMAKE_SKIP_RPATH=ON \
+	-DCMAKE_SKIP_RPATH:BOOL=ON \
+	-DCMAKE_INSTALL_RPATH_USE_LINK_PATH:BOOL=OFF \
 	-DCMAKE_BUILD_TYPE:STRING=RelWithDebInfo \
 	-DCAMITK_INSTALL_ROOT:PATH=/usr \
 	-DTOOL_CORESCHEMA:BOOL=ON \
@@ -30,16 +50,6 @@
 override_dh_auto_configure:
 	dh_auto_configure -- $(CMAKE_EXTRA_FLAGS)
 
-VER_MAJOR=3
-VER_MINOR=0
-VER_SHORT=$(VER_MAJOR).$(VER_MINOR)
-
-pkg_lib = libcamitk$(VER_MAJOR)
-pkg_dev = libcamitk$(VER_MAJOR)-dev
-pkg_data = libcamitk$(VER_MAJOR)-data
-pkg_doc = libcamitk$(VER_MAJOR)-doc
-pkg_imp = camitk-imp
-
 # let's be smart with doc
 override_dh_auto_build-indep:
 	$(MAKE) -C obj-* apidoc
@@ -51,17 +61,36 @@
 
 override_dh_install:
 	# camitk dynamic library
-	dh_install -p$(pkg_lib) debian/tmp/usr/lib/lib*.so.* usr/lib 
-	dh_install -p$(pkg_lib) --autodest debian/tmp/usr/lib/camitk-$(VER_SHORT)/actions/lib*.so
-	dh_install -p$(pkg_lib) --autodest debian/tmp/usr/lib/camitk-$(VER_SHORT)/components/lib*.so
+	dh_install -p$(pkg_lib) debian/tmp/usr/lib/libcamitkcore.so.* usr/lib 
+	dh_install -p$(pkg_lib) debian/tmp/usr/lib/libmonitoring.so.* usr/lib 
+	dh_install -p$(pkg_lib) --autodest debian/tmp/usr/lib/camitk-$(VER_SHORT)/actions/lib*.so.*
+	dh_install -p$(pkg_lib) --autodest debian/tmp/usr/lib/camitk-$(VER_SHORT)/components/lib*.so.*
 
-	# camitk headers and static libs + wizard
-	dh_install -p$(pkg_dev) debian/tmp/usr/lib/lib*.so usr/lib 
+	# separate tools qtpropertybrowser
+	dh_install -p$(pkg_qpb) debian/tmp/usr/lib/libqtpropertybrowser.so.* usr/lib
+
+	# camitk so and headers and static libs + wizard
+	dh_install -p$(pkg_dev) debian/tmp/usr/lib/libcamitkcore.so usr/lib 
+	dh_install -p$(pkg_dev) debian/tmp/usr/lib/libmonitoring.so usr/lib 
+	dh_install -p$(pkg_dev) --autodest debian/tmp/usr/lib/camitk-$(VER_SHORT)/actions/lib*.so
+	dh_install -p$(pkg_dev) --autodest debian/tmp/usr/lib/camitk-$(VER_SHORT)/components/lib*.so
 	dh_install -p$(pkg_dev) debian/tmp/usr/bin/camitk-wizard
 	dh_install -p$(pkg_dev) --autodest debian/tmp/usr/lib/camitk-$(VER_SHORT)/lib*.a
-	dh_install -p$(pkg_dev) --autodest debian/tmp/usr/include
+	dh_install -p$(pkg_dev) --autodest debian/tmp/usr/include/camitk-${VER_SHORT}/camitkcore
+	dh_install -p$(pkg_dev) --autodest debian/tmp/usr/include/camitk-${VER_SHORT}/coreschema
+	dh_install -p$(pkg_dev) --autodest debian/tmp/usr/include/camitk-${VER_SHORT}/actions
+	dh_install -p$(pkg_dev) --autodest debian/tmp/usr/include/camitk-${VER_SHORT}/components
+	dh_install -p$(pkg_dev) --autodest debian/tmp/usr/include/camitk-${VER_SHORT}/pml
+	dh_install -p$(pkg_dev) --autodest debian/tmp/usr/include/camitk-${VER_SHORT}/lml
+	dh_install -p$(pkg_dev) --autodest debian/tmp/usr/include/camitk-${VER_SHORT}/mml
+	dh_install -p$(pkg_dev) --autodest debian/tmp/usr/include/camitk-${VER_SHORT}/monitoring
+	dh_install -p$(pkg_dev) --autodest debian/tmp/usr/include/camitk-${VER_SHORT}/monitoringgui
 	dh_install -p$(pkg_dev) --autodest debian/tmp/usr/share/camitk-$(VER_SHORT)/cmake/*.cmake 
 	dh_installman -p$(pkg_dev) $(CURDIR)/applications/wizard/camitk-wizard.1
+
+        # qtpropertybrowser so and headers
+	dh_install -p$(pkg_qpb_dev) debian/tmp/usr/lib/libqtpropertybrowser.so usr/lib
+	dh_install -p$(pkg_qpb_dev) --autodest debian/tmp/usr/include/camitk-${VER_SHORT}/qtpropertybrowser
 
 	# api doc
 	dh_install -p$(pkg_doc) --autodest debian/tmp/usr/share/camitk-$(VER_SHORT)/apidoc

=== debian/watch ===
version=3
http://camitk.imag.fr/download_source.xml .*/camitk-(\d.*?)(?:-Source)?\.(?:tgz|tbz2|txz|tar\.(?:gz|bz2|xz))
# Bart Martens <bartm@debian.org>  Sat, 12 Jan 2013 18:53:23 +0000
